Material resource
{
	MaterialType _type = Opaque;
	VideoProgram _passes
	[ 
		"normal"
		"depth"
		"reflect"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\ModelLayout.rsc";
	VertexProgram _vertexProgram = "Material\Opaque\OpaqueMaterial.rsc:vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rs";
}

VideoProgram depth
{
	VertexLayout _vertexLayout = "MeshLayout\ModelDepthAlphaLayout.rsc";
	VertexProgram _vertexProgram = "vsDepth";
	PixelProgram _pixelProgram = "psDepth";
	RenderState _renderState = "rsDepth";
}

VideoProgram reflect
{
	VertexLayout _vertexLayout = "MeshLayout\ModelLayout.rsc";
	VertexProgram _vertexProgram = "Material\Opaque\OpaqueMaterial.rsc:vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rsRef";
}

RenderState rsDepth
{
	AlphaBlend _alphaBlend
	{
		bool _enable = false;
		Blend _source = One;
		Blend _dest = Zero;
		BlendOp _op = Add;
		ColorWrite _writeMask = Red | Green | Blue;
	}
	Depth _depth
	{
		bool _enable = true;
		bool _write = true;
		Compare _compare = LessEqual;
		float _bias = 0.0001000;
		float _slopeBias = 0.000100;
	}
	Stencil _stencil
	{
		bool _enable = false;
		bool _twosided = false;
		Compare _compare = Greater;
		uchar _ref = 0;
		StencilOp _fail = Keep;
		StencilOp _zFail = Keep;
		StencilOp _pass = Keep;
		StencilOp _tsFail = Keep;
		StencilOp _tsZFail = Keep;
		StencilOp _tsPass = Keep;
	}
	CullMode _cullMode = BackFaces;
	CullMode _fillMode = Solid;
}

PixelProgram ps : "Material\Opaque\OpaqueMaterial.rsc:ps"
{
	// replace sample function, alpha test
	String _functions
	[
		"
			float4 GetColor(float4 texcoord, float3 lightFog, float shadow)
			{
				float3 ao = Sample2D(aoMap, aoMapsampler, texcoord.zw).xxx;
				float4 color = Sample2D(diffuse, diffusesampler, texcoord.xy);
     
				float4 output;
				output.xyz = ComputeLighting(lightFog, color.xyz, shadow, float3(1, 1, 1), ao);
				output.w = 0;
				clip(color.w - 0.25);
	
				return output;
			}
		"
	]
}

VertexProgram vsDepth
{
	bool _instanced = true;
	VertexLayout _input = "MeshLayout/ModelDepthAlphaLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";		Usage _usage = Position;			int _index = 0; }
		{ String _type = "float2"; String _name = "texcoord";		Usage _usage = TextureCoordinate;	int _index = 0; }
	]

	Variant _variants
	[
		{
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.position.w);

				float3 position = input.position.xyz * localToWorld[3].xyz / 512.0;
				float3 worldPosition = mul((float3x4)localToWorld, float4(position.xyz, 1.0));
	
				output.position = mul(gc_worldToProjection, float4(worldPosition, 1.0));
				output.texcoord = input.texcoord.xy / float2(512.0, 512.0);
			";
		}
	]
}

PixelProgram psDepth
{
	VertexProgram _input = "vsDepth";

	String _includes
	[
		"Material/Texture.hlsl"
	]

	Texture _textureList
	[
		{ bool _2d = true;	String _name = "diffuse";	int _bindIndex = 0;	bool _exposed = true; }
	]

	Variant _variants
	[
		{
			String _text = "
				output.color = Sample2D(diffuse, diffusesampler, input.texcoord);
				clip(output.color.a - 0.25);
				
			";
		}
	]
}