Material resource
{
	MaterialType _type = Opaque;
	VideoProgram _passes
	[ 
		"normal"
		"depth"
		"reflect"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\ModelBillboardLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "rs";
}

VideoProgram depth
{
	VertexLayout _vertexLayout = "MeshLayout\ModelBillboardLayout.rsc";
	VertexProgram _vertexProgram = "vsDepth";
	PixelProgram _pixelProgram = "psDepth";
	RenderState _renderState = "rsDepth";
}

VideoProgram reflect
{
	VertexLayout _vertexLayout = "MeshLayout\ModelBillboardLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "rs";
}

RenderState rs
{
	AlphaBlend _alphaBlend
	{
		bool _enable = false;
		Blend _source = One;
		Blend _dest = Zero;
		BlendOp _op = Add;
		ColorWrite _writeMask = Red | Green | Blue | Alpha;
	}
	Depth _depth
	{
		bool _enable = true;
		bool _write = true;
		Compare _compare = LessEqual;
		float _bias = 0.000000;
		float _slopeBias = 0.000000;
	}
	Stencil _stencil
	{
		bool _enable = false;
		bool _twosided = false;
		Compare _compare = Greater;
		uchar _ref = 0;
		StencilOp _fail = Keep;
		StencilOp _zFail = Keep;
		StencilOp _pass = Keep;
		StencilOp _tsFail = Keep;
		StencilOp _tsZFail = Keep;
		StencilOp _tsPass = Keep;
	}
	CullMode _cullMode = None;
	CullMode _fillMode = Solid;
}

RenderState rsDepth
{
	AlphaBlend _alphaBlend
	{
		bool _enable = false;
		Blend _source = One;
		Blend _dest = Zero;
		BlendOp _op = Add;
		ColorWrite _writeMask = 0;
	}
	Depth _depth
	{
		bool _enable = true;
		bool _write = true;
		Compare _compare = LessEqual;
		float _bias = 0.000000;
		float _slopeBias = 0.000000;
	}
	Stencil _stencil
	{
		bool _enable = false;
		bool _twosided = false;
		Compare _compare = Greater;
		uchar _ref = 0;
		StencilOp _fail = Keep;
		StencilOp _zFail = Keep;
		StencilOp _pass = Keep;
		StencilOp _tsFail = Keep;
		StencilOp _tsZFail = Keep;
		StencilOp _tsPass = Keep;
	}
	CullMode _cullMode = None;
	CullMode _fillMode = Solid;
}

VertexProgram vs
{
	bool _instanced = true;
	VertexLayout _input = "MeshLayout/ModelBillboardLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
		"Material/Lighting.hlsl"
		"Material/Billboard.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";		Usage _usage = Position;			int _index = 0; }
		{ String _type = "float4"; String _name = "texcoord";		Usage _usage = TextureCoordinate;	int _index = 0; }
		{ String _type = "float4"; String _name = "lightFogMove";	Usage _usage = TextureCoordinate;	int _index = 1; }
	]

	String _functions
	[
		"
		void Common(float4x4 localToWorld, float4 position, float4 texcoord, float3 normal, float2 userData, out float3 worldPosition, out float4 outputPosition,
			out float4 outputTexcoord, out float4 lightFogMove)
		{
			normal = normalize(normal * 2 - 1);
			normal = mul((float3x3)localToWorld, normal).xyz;
			float3 cameraNormal = mul((float3x3)gc_worldToCamera, normal);
	
			position.xyz *= 1.0 / 512.0;
			float move = step(0.05, abs(dot(userData, userData)));

			float3 billboardNormal;
			cameraNormal *= move;
	
			position.xyz *= localToWorld[3].xyz;
			worldPosition = mul((float3x4)localToWorld, float4(position.xyz, 1.0));
			
	
			worldPosition = Billboard(worldPosition, localToWorld[3].xyz, move, billboardNormal, cameraNormal, gc_worldToCamera, userData / 8192);
		
			outputPosition = mul(gc_worldToProjection, float4(worldPosition, 1.0));
	
			billboardNormal = normalize(position.xyz + float3(0, 0, 4));
			normal = normal * (1.0 - move) + billboardNormal * move;
	
			lightFogMove.xyz = GetLightingFog(normal, outputPosition.w);
			lightFogMove.w = move;

			outputTexcoord = texcoord / float4(512.0, 512.0, 8192.0, 8192.0);
		}
		"
	]

	Variant _variants
	[
		{
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.position.w);
				float3 worldPosition;
				Common(localToWorld, input.position, input.texcoord, input.normal.xyz, input.userData, worldPosition, output.position, output.texcoord, output.lightFogMove);
			";
		}
		{
			Output _outputs 
			[
				{ String _type = "float4"; String _name = "shadowProjection";	Usage _usage = TextureCoordinate;	int _index = 2; }
			]
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.position.w);
				float3 worldPosition;
				Common(localToWorld, input.position, input.texcoord, input.normal.xyz, input.userData, worldPosition, output.position, output.texcoord, output.lightFogMove);
				output.shadowProjection = mul(lc_shadowProjection0, float4(worldPosition, 1.0f));
			";
		}
		{
			Output _outputs 
			[
				{ String _type = "float4"; String _name = "shadowProjection";	Usage _usage = TextureCoordinate;	int _index = 2; }
			]
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.position.w);
				float3 worldPosition;
				Common(localToWorld, input.position, input.texcoord, input.normal.xyz, input.userData, worldPosition, output.position, output.texcoord, output.lightFogMove);
				output.shadowProjection = mul(lc_shadowProjection0, float4(worldPosition, 1.0f));
			";
		}
		{
			Output _outputs 
			[
				{ String _type = "float4"; String _name = "shadowProjection";	Usage _usage = TextureCoordinate;	int _index = 2; }
			]
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.position.w);
				float3 worldPosition;
				Common(localToWorld, input.position, input.texcoord, input.normal.xyz, input.userData, worldPosition, output.position, output.texcoord, output.lightFogMove);
				output.shadowProjection = mul(lc_shadowProjection0, float4(worldPosition, 1.0f));
			";
		}
	]
}

PixelProgram ps
{
	VertexProgram _input = "vs";
	String _includes
	[
		"Material/Texture.hlsl"
		"Material/Shadows.hlsl"
	]

	Texture _textureList
	[
		{ bool _2d = true;	String _name = "diffuse";		int _bindIndex = 0;	bool _exposed = true; }
		{ bool _2d = true;	String _name = "aoMap";			int _bindIndex = 3;	bool _exposed = false; }
		{ bool _2d = true;	String _name = "shadowMap";		int _bindIndex = 5;	bool _exposed = false; bool _shadowMap = true; }
	]

	String _functions
	[
		"
			float4 GetColor(float4 texcoord, float4 lightFogMove, float shadow)
			{
				float3 ao = Sample2D(aoMap, aoMapsampler, texcoord.zw).xxx;
				float4 diff = Sample2D(diffuse, diffusesampler, texcoord.xy);
    
				float3 fallColor = dot(diff.xyz, diff.xyz) * float3(233.0 / 255.0, 185.0 / 255.0, 71.0 / 255.0);
				diff.xyz = lerp(diff.xyz, fallColor, pc_userPosition.y * lightFogMove.w);
    
				float4 output;
				output.xyz = ComputeLighting(lightFogMove.xyz, diff.xyz, shadow, float3(1, 1, 1), ao);
				output.w = 0;
				clip((diff.w - (lightFogMove.w * pc_userPosition.z)) - 0.5);

				return output;
			}
		"
	]

	Variant _variants
	[
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogMove, 1);";
		}
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogMove, GetShadowLow(input.shadowProjection));";
		}
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogMove, GetShadowMediumStar(input.shadowProjection, pc_texelSize.x));";
		}
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogMove, GetShadowHighStar(input.shadowProjection, pc_texelSize.x));";
		}
	]
}

VertexProgram vsDepth
{
	bool _instanced = true;
	VertexLayout _input = "MeshLayout/ModelBillboardLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
		"Material/Billboard.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";		Usage _usage = Position;			int _index = 0; }
		{ String _type = "float2"; String _name = "texcoord";		Usage _usage = TextureCoordinate;	int _index = 0; }
		{ String _type = "float2"; String _name = "seasonData";		Usage _usage = TextureCoordinate;	int _index = 1; }
	]

	Variant _variants
	[
		{
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.position.w);
				float3 position = input.position.xyz * localToWorld[3].xyz / 512.0;

				float3 normal = input.normal.xyz;
				normal = mul((float3x3)localToWorld, normalize(normal * 2 - 1)).xyz;
				float3 cameraNormal = mul((float3x3)gc_worldToCamera, normal.xyz);
	
				float2 userData = input.userData;
				float3 worldPosition = mul((float3x4)localToWorld, float4(position.xyz, 1.0));
				float move = step(0.05, abs(dot(userData, userData)));
				worldPosition = Billboard(worldPosition, localToWorld[3].xyz, move, normal.xyz, cameraNormal, gc_worldToCamera, userData / 8192);
		
				output.position = mul(gc_worldToProjection, float4(worldPosition, 1.0));
				output.texcoord = input.texcoord.xy / float2(512.0, 512.0);
	
				output.seasonData.xy = gc_userPosition.z * move;
			";
		}
	]
}

PixelProgram psDepth
{
	VertexProgram _input = "vsDepth";

	String _includes
	[
		"Material/Texture.hlsl"
	]

	Texture _textureList
	[
		{ bool _2d = true;	String _name = "diffuse";	int _bindIndex = 0;	bool _exposed = true; }
	]

	Variant _variants
	[
		{
			String _text = "
				float4 diff = Sample2D(diffuse, diffusesampler, input.texcoord);
				output.color = diff;
				output.color.w -= input.seasonData.x;
				clip(output.color.w - 0.5);
			";
		}
	]
}