Material resource
{
	MaterialType _type = Blended;
	VideoProgram _passes
	[ 
		"normal"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\DebugLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "rs";
}

RenderState rs
{
	AlphaBlend _alphaBlend
	{
		bool _enable = true;
		Blend _source = SourceAlpha;
		Blend _dest = InverseSourceAlpha;
		BlendOp _op = Add;
		ColorWrite _writeMask = Red | Green | Blue | Alpha;
	}
	Depth _depth
	{
		bool _enable = true;
		bool _write = true;
		Compare _compare = Always;
		float _bias = 0.000000;
		float _slopeBias = 0.000000;
	}
	Stencil _stencil
	{
		bool _enable = false;
		bool _twosided = false;
		Compare _compare = Greater;
		uchar _ref = 0;
		StencilOp _fail = Keep;
		StencilOp _zFail = Keep;
		StencilOp _pass = Keep;
		StencilOp _tsFail = Keep;
		StencilOp _tsZFail = Keep;
		StencilOp _tsPass = Keep;
	}
	CullMode _cullMode = BackFaces;
	CullMode _fillMode = Solid;
}

VertexProgram vs
{
	VertexLayout _input = "MeshLayout\DebugLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";	Usage _usage = Position;			int _index = 0; }
		{ String _type = "float4"; String _name = "color";		Usage _usage = Color;				int _index = 0; }
	]

	Variant _variants
	[
		{
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(0);
				float3 worldPosition = mul((float3x4)localToWorld, float4(input.position, 1.0));

				output.position = mul(gc_worldToProjection, float4(worldPosition, 1.0));
				output.color = input.color;
			";
		}
	]
}

PixelProgram ps
{
	VertexProgram _input = "vs";

	Variant _variants
	[
		// main
		{
			String _text = "output.color = input.color;";
		}
	]
}