Material resource
{
	MaterialType _type = Opaque;
	VideoProgram _passes
	[ 
		"normal"
		"depth"
		"reflect"			
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\ModelLayout.rsc";
	VertexProgram _vertexProgram = "Material\OpaqueSnow\OpaqueSnowMaterial.rsc:vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rs";
}

VideoProgram depth
{
	VertexLayout _vertexLayout = "MeshLayout\ModelDepthLayout.rsc";
	VertexProgram _vertexProgram = "Material\Opaque\OpaqueMaterial.rsc:vsDepth";
	PixelProgram _pixelProgram = "Material\Opaque\OpaqueMaterial.rsc:psDepth";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rsDepth";
}

VideoProgram reflect
{
	VertexLayout _vertexLayout = "MeshLayout\ModelLayout.rsc";
	VertexProgram _vertexProgram = "Material\OpaqueSnow\OpaqueSnowMaterial.rsc:vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rsRef";
}

PixelProgram ps : "Material\OpaqueSnow\OpaqueSnowMaterial.rsc:ps"
{
	VertexProgram _input = "Material\OpaqueSnow\OpaqueSnowMaterial.rsc:vs";

	Texture _textureList
	[
		{ bool _2d = true;	String _name = "diffuse";	int _bindIndex = 0;	bool _exposed = true; }
		{ bool _2d = true;	String _name = "damage";	int _bindIndex = 1;	bool _exposed = true; }
		{ bool _2d = true;	String _name = "snow";		int _bindIndex = 2;	bool _exposed = true; }
		{ bool _2d = true;	String _name = "aoMap";		int _bindIndex = 3;	bool _exposed = false; bool _shadowMap = false; }
		{ bool _2d = true;	String _name = "shadowMap";	int _bindIndex = 5;	bool _exposed = false; bool _shadowMap = true; }
	]

	String _functions
	[
		"
			float4 GetColor(float4 texcoord, float3 lightFog, float3 seasonData, float shadow)
			{
				float4 diff = Sample2D(diffuse, diffusesampler, texcoord.xy);
				float3 dam = Sample2D(damage, damagesampler, (texcoord.zw * 4.0)).xyz;
				float3 sno = Sample2D(snow, snowsampler, seasonData.xy).xyz;
				float3 ao = Sample2D(aoMap, aoMapsampler, texcoord.zw).xxx;

				float amount = 1 - dot(diff.xyx, diff.xyz);
				amount = saturate(min(0.75, 1 - (amount * amount)));
				diff.xyz = lerp(diff.xyz, dam, amount);
    
				diff.xyz = lerp(diff.xyz, sno, pc_userPosition.x * seasonData.z * diff.w * ao.x * ao.x);
    
				float4 output;
				output.xyz = ComputeLighting(lightFog, diff.xyz, shadow, float3(1, 1, 1), ao);
				output.w = 0;
	
				return output;
			}
		"
	]
}
