Material resource
{
	MaterialType _type = Blended;
	VideoProgram _passes
	[ 
		"normal"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\TerrainDecalLayout.rsc";
	VertexProgram _vertexProgram = "Material\TerrainDecal\TerrainDecalMaterial.rsc:vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "Material\TerrainDecal\TerrainDecalMaterial.rsc:rs";
}

PixelProgram ps : "Material\TerrainDecal\TerrainDecalMaterial.rsc:ps"
{
	VertexProgram _input = "Material\TerrainDecal\TerrainDecalMaterial.rsc:vs";


	Texture _textureList
	[
		{ bool _2d = true;	String _name = "diffuse";	int _bindIndex = 0;	bool _exposed = true; }
		{ bool _2d = true;	String _name = "damage";	int _bindIndex = 1;	bool _exposed = true; bool _shadowMap = false; }
		{ bool _2d = true;	String _name = "shadowMap";	int _bindIndex = 5;	bool _exposed = false; bool _shadowMap = true; }
	]

	String _functions
	[
		"
			float4 GetColor(float3 texcoord, float4 lightFogAlpha, float shadow)
			{
				float4 diff = Sample2D(diffuse, diffusesampler, texcoord.xy);
				float4 dam = Sample2D(damage, damagesampler, (texcoord.xy * 2));

				diff.xyz = lerp(diff.xyz, dam.xyz, 0.7);
    
				float4 output;
				output.w = max((1.0 - pc_userPosition.x), dam.w) * diff.w * lightFogAlpha.w;
				output.xyz = ComputeLighting(lightFogAlpha.xyz, diff.xyz, shadow);
				output.xyz = lerp(output.xyz, float3(0.025, 0.123, 0.19), saturate(texcoord.z));
				
	
				return output;
			}
		"
	]

	Variant _variants
	[
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogAlpha, 1);";
		}
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogAlpha, GetShadowLow(input.shadowProjection));";
		}
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogAlpha, GetShadowMedium(input.shadowProjection, pc_texelSize.x));";
		}
		{
			String _text = "output.color = GetColor(input.texcoord, input.lightFogAlpha, GetShadowMedium(input.shadowProjection, pc_texelSize.x));";
		}
	]
}
